<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Debug ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Debug extends AbstractStructArrayBase
{
    /**
     * The Debug
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Debug[]
     */
    public $Debug;
    /**
     * Constructor method for ArrayOfJP_Debug
     * @uses ArrayOfJP_Debug::setDebug()
     * @param \StructType\JP_Debug[] $debug
     */
    public function __construct(array $debug = array())
    {
        $this
            ->setDebug($debug);
    }
    /**
     * Get Debug value
     * @return \StructType\JP_Debug[]|null
     */
    public function getDebug()
    {
        return $this->Debug;
    }
    /**
     * This method is responsible for validating the values passed to the setDebug method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDebug method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDebugForArrayConstraintsFromSetDebug(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_DebugDebugItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_DebugDebugItem instanceof \StructType\JP_Debug) {
                $invalidValues[] = is_object($arrayOfJP_DebugDebugItem) ? get_class($arrayOfJP_DebugDebugItem) : sprintf('%s(%s)', gettype($arrayOfJP_DebugDebugItem), var_export($arrayOfJP_DebugDebugItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Debug property can only contain items of type \StructType\JP_Debug, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Debug value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Debug[] $debug
     * @return \ArrayType\ArrayOfJP_Debug
     */
    public function setDebug(array $debug = array())
    {
        // validation for constraint: array
        if ('' !== ($debugArrayErrorMessage = self::validateDebugForArrayConstraintsFromSetDebug($debug))) {
            throw new \InvalidArgumentException($debugArrayErrorMessage, __LINE__);
        }
        $this->Debug = $debug;
        return $this;
    }
    /**
     * Add item to Debug value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Debug $item
     * @return \ArrayType\ArrayOfJP_Debug
     */
    public function addToDebug(\StructType\JP_Debug $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Debug) {
            throw new \InvalidArgumentException(sprintf('The Debug property can only contain items of type \StructType\JP_Debug, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Debug[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Debug|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Debug|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Debug|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Debug|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Debug|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Debug
     */
    public function getAttributeName()
    {
        return 'Debug';
    }
}
